LeetCode - Two Sum 完整代码

LeetCode - Two Sum 完整代码(C++)

C++暴力法

#include <iostream>    
#include <vector>    
using namespace std;


vector<int> twoSum(vector<int>& nums, int target) {
    int n = nums.size();
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (nums[i] + nums[j] == target) {
                return {i, j};
            }
        }
    }
    return {};
}
int main()
{
    int num[5] = { 1,6,7,8,9 };
    vector<int> nums(num, num + 5);
    int target = 7;
    vector<int> result;
    result = twoSum(nums, target);
    cout << result[0] << "," << result[1] << endl;

    return 0;
}

时间复杂度:O(N^2).其中 N 是数组中的元素数量。最坏情况下数组中任意两个数都要被匹配一次。

空间复杂度:O(1)。


\

注意到方法一的时间复杂度较高的原因是寻找 target - x 的时间复杂度过高。因此,我们需要一种更优秀的方法,能够快速寻找数组中是否存在目标元素。如果存在,我们需要找出它的索引。
使用哈希表,可以将寻找 target - x 的时间复杂度降低到从 O(N) 降低到 O(1)

C++哈希表法

#include <iostream>
#include <unordered_map>
#include <vector>
using namespace std;

vector<int> twoSum(vector<int>& nums, int target) {
    unordered_map<int, int> hashtable;
    for (int i = 0; i < nums.size(); ++i) {
        auto it = hashtable.find(target - nums[i]);
        if (it != hashtable.end()) {
            return { it->second, i };
        }
        hashtable[nums[i]] = i;
    }
    return {};
}


int main()
{
	int num[5] = { 1,6,7,8,9 };
	vector<int> nums(num, num + 5);
	int target = 7;
	vector<int> result;
	result = twoSum(nums, target);
	cout << result[0] << "," << result[1] << endl;

	return 0;
}




\

复杂度分析

时间复杂度:O(N),其中 N 是数组中的元素数量。对于每一个元素 x,我们可以 O(1) 地寻找 target - x。

空间复杂度:O(N),其中 N 是数组中的元素数量。主要为哈希表的开销。

本题知识点

c++ map与unordered_map区别
需要引入不同的头文件
map: #include < map >
unordered_map: #include < unordered_map >
unordered_map执行效率要比map高
map:优点:有序性

it->first会得到key,
it->second会得到value。

  • 1
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
```c /** * Definition for singly-linked list. * struct ListNode { * int val; * struct ListNode *next; * }; */ struct ListNode* addTwoNumbers(struct ListNode* l1, struct ListNode* l2) { struct ListNode* head = NULL; struct ListNode* tail = NULL; int carry = 0; while(l1 != NULL || l2 != NULL){ int n1 = (l1 != NULL) ? l1->val : 0; int n2 = (l2 != NULL) ? l2->val : 0; int sum = n1 + n2 + carry; carry = sum / 10; struct ListNode* newNode = (struct ListNode*)malloc(sizeof(struct ListNode)); newNode->val = sum % 10; newNode->next = NULL; if(head == NULL){ head = newNode; tail = newNode; }else{ tail->next = newNode; tail = newNode; } if(l1 != NULL){ l1 = l1->next; } if(l2 != NULL){ l2 = l2->next; } } if(carry > 0){ struct ListNode* newNode = (struct ListNode*)malloc(sizeof(struct ListNode)); newNode->val = carry; newNode->next = NULL; tail->next = newNode; tail = newNode; } return head; } ``` 这是leetcode题目“两数相加”的完整C语言解法。首先定义了一个结构体`ListNode`来表示单链表的结点。然后,我们使用头尾指针`head`和`tail`来创建新的结果链表。我们还定义了一个变量`carry`来保存进位值。 在循环中,我们分别取出两个链表当前结点的值,并与进位值相加。如果链表的长度不一致,我们使用0来代替较短链表的缺失结点值。然后,我们将求和结果的个位数作为新结点的值,并更新进位值。 接着,我们创建新结点并将其加入结果链表中。第一个新结点既是头指针也是尾指针,而后续新结点都仅作为尾指针的next指向。 最后,如果进位值大于0,我们将其作为新结点加入结果链表的尾部。 最后返回头指针head即可。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值